#include <stdio.h>
#include <stdlib.h>
#include "FrameBuffer.h"

FrameBuffer::FrameBuffer(int _w, int _h)
{
   width  = _w;
   height = _h;

   /* allocate the pixel buffer */
   pixel_buffer = (unsigned char *)malloc(sizeof(unsigned char) * width * height * 3);
   if (!pixel_buffer)
   {
      fprintf(stderr, "ERROR! Unable to allocate memory for frame buffer\n");
      fflush(stderr);
      exit(-1);
   }
}


FrameBuffer::~FrameBuffer()
{
   if (pixel_buffer)
      free(pixel_buffer);
}


/* get color ptr */
unsigned char * FrameBuffer::getColorPtr(int x, int y)
{
   return (pixel_buffer + ((y * width + x)*3));
}


void FrameBuffer::renderScene(Scene *s)
{
   TriangleListNode *ptr;

   /* render the triangles in the list */
   for (ptr = s->head_ptr; ptr;)
   {
      renderTriangle(ptr->t);
      ptr = ptr->next;
   }
   return;
}//renderScene()


/* for software rendering of the triangle */
void FrameBuffer::renderTriangle(Triangle *t)
{
   /* Not done yet */

   return;
}//renderTriangle()



#if 0  // "comment out" this function
/* this function dumps the color framebuffer to the specified file. */
void FrameBuffer::dumpToFile(char *name)
{
   // need to create the file first

   int i, j;
   int pitch = image->GetPitch();
   unsigned int *ptr_dst = (unsigned int*)image->GetBits();
   unsigned int *ptr_src = getColorPtr(0, height - 1);

   /* note that CImage is upside down, so we start reading
      the framebuffer from the top of the screen */
   for (j = 0; j < height; j++)
   {
      for (i = 0; i < width; i++)
      {
         *(ptr_dst++) = *(ptr_src + 2);
         *(ptr_dst++) = *(ptr_src + 1);
         *(ptr_dst++) = *(ptr_src);

         ptr_src += 3;
      }

      ptr_src += -(width * 3) * 2;
      ptr_dst += pitch - (width * 3);
   }
   return;
}
#endif // end "comment"
