#ifndef FRAMEBUFFER_H
#define FRAMEBUFFER_H

#include "Scene.h"
#include "Triangle.h"

class FrameBuffer
{
   private:
   public:
      int width;
      int height;
      unsigned char *pixel_buffer; /* contains the pixel color data for a rendered frame */

      FrameBuffer(int _w, int _h);

      ~FrameBuffer();

      /* get color ptr */
      unsigned char * getColorPtr(int x, int y);

      /* render a Scene or a Triangle into this FrameBuffer */
      void renderScene(Scene *s);
      void renderTriangle(Triangle *t);

      void dumpToFile(char *name);
};

#endif /* FRAMEBUFFER_H */
