#ifndef SCENE_H
#define SCENE_H

#include "TriangleListNode.h"
#include "Triangle.h"
#include "Texture.h"

class Scene
{
   private:
      void destroyList();

   public:
      /* the scene class is basically a linked list of triangles */
      TriangleListNode *head_ptr;
      TriangleListNode *tail_ptr;
      /* with an array of pointers to Texture objects */
      Texture * textures[256];
      int textureCount;

      Scene();

      ~Scene();

      void addTriangle( Triangle *tri );

      void addTexture( Texture *tex );

      void setProjectionMatrix(float eye_fov, float aspect_ratio, float near, float far);
      void setViewMatrix(float *eye_pos, float eye_theta, float eye_phi);
      void setModelMatrix(  );
};

#endif /* SCENE_H */
