#ifndef TRIANGLE_H
#define TRIANGLE_H

#include "Vertex.h"
#include "Texture.h"

class Triangle
{
   private:
   public:
      Vertex v[3];  /* the vertices of the triangle */
                          /* per-vertex values */
      float c[3][3];      /* color at each vertex */
      float coords[3][2]; /* texture coordinates at each vertex */

      Texture *tex; /* point to the texture that is bound, if any */

      Triangle();

      Triangle(Vertex *v0, Vertex *v1, Vertex *v2);


      /* sets the texture coordinate of vertex v to (s, t) */
      void setCoords(int v, float s, float t);

//      /* sets the texture coordinate of vertex v to (s, t) */
//      void setCoords(int v, int s, int t);

      /* sets the color of vertex v to (r,g,b) */
      void setColor(int v, int r, int g, int b);

      void setTexture(Texture *t);

      /* for debugging */
      void print(void);
};

#endif  /* TRIANGLE_H */
